(**************************************************************************)
(*                                                                        *)
(*                         The Zen/Aum Library                            *)
(*                                                                        *)
(*                              Grard Huet                               *)
(*                                                                        *)
(* 2005 Institut National de Recherche en Informatique et en Automatique *)
(**************************************************************************)

(* Mechanically generated by [print_automaton] from source example.aut    *)
(* using the [Regular] module of Benoit Razet with the Camlp4 library     *)

module Automata (Auto : sig type auto; end) =
  struct
    type auto_vect =
      { epsilon_aum : Auto.auto; a : Auto.auto; b : Auto.auto; c : Auto.auto
      };
    module Disp (Fsm : sig value autos : auto_vect; end) =
      struct
        type phase = [ Init | A1 | B1 | C | A2 | B2 ];
        value transducer =
          fun
          [ Init -> Fsm.autos.epsilon_aum
          | A1 -> Fsm.autos.a
          | B1 -> Fsm.autos.b
          | C -> Fsm.autos.c
          | A2 -> Fsm.autos.a
          | B2 -> Fsm.autos.b ];
        value dispatch =
          fun
          [ Init -> [ A1; B1 ]
          | A1 -> [ A1; B1 ]
          | B1 -> [ C ]
          | C -> [ A2; B2 ]
          | A2 -> [ A2; B2 ]
          | B2 -> [] ];
        value initial = Init;
        value terminal phase = List.mem phase [ B2 ];
      end;
  end;

